/*
	UserPlugIn.h File Generated by DSP Designer
	Copyright(c) 2010 Will Pirkle

	For Academic Use Only
*/

#pragma once

#include "pluginconstants.h"
#include "FFT.h"
#include "plugin.h"

// WP
#define FFT_LEN 1024


// abstract base class for DSP filters
class CMultiThreadFFT : public CPlugIn
{
public:	// Plug-In API Functions
	// Plug-In API Member Methods:
	// The followung 8 methods must be impelemented for a meaningful Plug-In
	//
	// 1. One Time Initialization
	CMultiThreadFFT();

	// 2. One Time Destruction
	virtual ~CMultiThreadFFT(void);

	// 3. initUI() is called when the UI needs to be updated to reflect a Preset Load or Initial State
	virtual bool __stdcall initUI();

	// 4. Initialization for after the Plug-In has been instantiated
	virtual bool __stdcall init();

	// 5. The Prepare For Play Function is called just before the first Process function
	virtual bool __stdcall prepareForPlay();

	// 6. pause() is called when the audio data stops streaming
	virtual bool __stdcall pause();

	// 7. processAudioFrame() processes an audio input to create an audio output
	virtual bool __stdcall processAudioFrame(float* pInputBuffer, float* pOutputBuffer, UINT uNumInputChannels, UINT uNumOutputChannels);

	// 8. userInterfaceChange() occurs when the user moves a control.
	virtual bool __stdcall userInterfaceChange(int nControlIndex);


	// OPTIONAL ADVANCED METHODS ------------------------------------------------------------------------------------------------
	// These are more advanced; see the book for more details
	//
	// 9. joystickControlChange() occurs when the user moves a control.
	virtual bool __stdcall joystickControlChange(float fControlA, float fControlB, float fControlC, float fControlD, float fACMix, float fBDMix);

	// 10. process buffers instead of Frames:
	// NOTE: set m_bWantBuffers = true to use this function
	virtual bool __stdcall processSocketAudioBuffer(float* pInputBuffer, float* pOutputBuffer, UINT uNumInputChannels, UINT uNumOutputChannels, UINT uBufferSize);

	// 11. rocess buffers instead of Frames:
	// NOTE: set m_bWantVSTBuffers = true to use this function
	virtual bool __stdcall processVSTAudioBuffer(float** ppInputs, float** ppOutputs, UINT uNumChannels, int uNumFrames);

	// 12. MIDI Note On Event
	virtual bool __stdcall midiNoteOn(UINT uChannel, UINT uMIDINote, UINT uVelocity);

	// 13. MIDI Note Off Event
	virtual bool __stdcall midiNoteOff(UINT uChannel, UINT uMIDINote, UINT uVelocity, bool bAllNotesOff);

	// 14. all MIDI messages -
	// NOTE: set m_bWantAllMIDIMessages true to get everything else (other than note on/off)
	virtual bool __stdcall midiMessage(unsigned char cChannel, unsigned char cStatus, unsigned char cData1, unsigned char cData2);


	// Add your code here: ----------------------------------------------------------- //
	HANDLE m_hFFTThread;
	HANDLE m_hFFTCallbackThread;
	HANDLE m_hFFTStartEvent;
	HANDLE m_hFFTDoneEvent;

	int m_nSampleCount;
	double m_dAudio_In[FFT_LEN];
	double m_dFFT_In[FFT_LEN];
	double m_dFFT_OutRe[FFT_LEN];
	double m_dFFT_OutIm[FFT_LEN];
	double m_dFFT_Magnitude[FFT_LEN/2];

	void doFFT();



	// END OF USER CODE -------------------------------------------------------------- //


	// ADDED BY SOCKET -- DO NOT EDIT THIS CODE!!! ----------------------------------- //
	//  **--0x07FD--**

	float m_f86HzMeterValue;
	float m_f172HzMeterValue;
	float m_f344HzMeterValue;
	float m_f688HzMeterValue;
	float m_f1376HzMeterValue;
	float m_f2752HzMeterValue;
	float m_f5504HzMeterValue;
	float m_f11008HzMeterValue;
	float m_f22050HzMeterValue;
	float m_f43HzMeterValue;

	// **--0x1A7F--**
	// ------------------------------------------------------------------------------- //

};
























































